program main
use random
use constants
implicit none 

integer, parameter :: Np = 90000
double precision :: x(1:Np)
double precision :: y, z, sigma
integer :: i, j, k, is
double precision :: delta_t

delta_t = 0.04 

do is = 1, 100
x = 0
do i=1, Np
    z = 0
    
    ! calculation of int_0^t dwt 
    ! t = 1000 * is * delta_t 
    ! random_normal() \sim N(0, 1)
    ! random_normal() * sqrt(delta_t) \sim N(0, delta_t)

    do j=1, 1000 * is
        y = random_normal() * sqrt(delta_t)
        z = z + y 
    end do
    x(i) = z
end do

sigma=0.0 
do i=1, Np
sigma = sigma + x(i) *x(i) 
end do

sigma = sigma / Np

write(*, *) 1000 * is * delta_t,  sigma

end do


end program

! output 
!    40.0000000       39.886218159829369     
!   80.0000000       79.996277262529361     
!   120.000000       120.20720952752026     
!   160.000000       159.43002215934550     
!   200.000000       199.22156485129372     
!   240.000000       239.50377587620795     
!   280.000000       280.32426384605839     
 




